package my.framework;

import java.lang.annotation.Annotation;
import java.lang.reflect.Type;
import java.util.Collections;
import java.util.HashSet;
import java.util.Set;

import javax.enterprise.context.RequestScoped;
import javax.enterprise.context.spi.CreationalContext;
import javax.enterprise.inject.AnnotationLiteral;
import javax.enterprise.inject.Default;
import javax.enterprise.inject.spi.Bean;
import javax.enterprise.inject.spi.InjectionPoint;

import org.glassfish.test299.ABeanInterface;

public class ABeanDefinition implements Bean<ABeanInterface> {
    static HashSet<Annotation> hs = new HashSet<Annotation>();
    
    static {
        hs.add(new AnnotationLiteral<Default>() {
        });                
    }

    public Set getTypes() {
        HashSet<Type> hs = new HashSet<Type>();
        hs.add(ABeanInterface.class);
        hs.add(ABeanImpl.class);
        hs.add(Object.class);
        return hs;
    }

    public Class<?> getBeanClass() {
        return ABeanImpl.class;
    }

    public Set<Annotation> getQualifiers() {
        return hs;
    }

    public Class<? extends Annotation> getScope() {
        return RequestScoped.class;
    }

    public String getName() {
        return "AContext";
    }

    public Set<Class<? extends Annotation>> getStereotypes() {
        return new HashSet();
        //return Collections.emptySet();
    }

    public boolean isAlternative() {
        return false;
    }

    public boolean isNullable() {
        return true;
    }

    public Set<InjectionPoint> getInjectionPoints() {
        return new HashSet<InjectionPoint>();        
        //return Collections.<InjectionPoint> emptySet();
    }

    public ABeanInterface create(CreationalContext<ABeanInterface> cc) {
        return new ABeanImpl();        
    }

    public void destroy(ABeanInterface o, CreationalContext<ABeanInterface> cc) {

    }
}