package my.framework;

import java.util.logging.Logger;

import javax.enterprise.event.Observes;
import javax.enterprise.inject.spi.AfterBeanDiscovery;
import javax.enterprise.inject.spi.BeanManager;
import javax.enterprise.inject.spi.BeforeBeanDiscovery;
import javax.enterprise.inject.spi.BeforeShutdown;

public class Extension implements javax.enterprise.inject.spi.Extension {

    static Logger l = Logger.getLogger("testlogger");
    
    public void beforeBeanDiscovery(@Observes BeforeBeanDiscovery bbd, BeanManager manager) {                
        l.info("Before bean discovery " + manager);
    }
    
    public void afterBeanDiscovery(@Observes AfterBeanDiscovery abd, BeanManager bm) {
        //Lets add the bean definition.
        abd.addBean(new ABeanDefinition());                                        
        l.info("After bean discovery.... BeanM" + bm);
    }
                    
    void beforeShutdown(@Observes BeforeShutdown event, BeanManager manager) {
        l.info("Before shutting down ");
    }
}